Index: issm/trunk/src/c/classes/FemModel.h
===================================================================
--- issm/trunk/src/c/classes/FemModel.h	(revision 13405)
+++ issm/trunk/src/c/classes/FemModel.h	(revision 13975)
@@ -19,6 +19,7 @@
 class Loads;
 class Materials;
+class Profiler;
+class Elements;
 /*}}}*/
-
 
 class FemModel {
@@ -28,29 +29,71 @@
 	public:
 
-		int                 nummodels;
-		int                 solution_type;
-		int*                analysis_type_list; //list of analyses this femmodel is going to carry out
-		int                 analysis_counter; //counter into analysis_type_list
-		
-		Elements*           elements; //elements (one set for all analyses)
-		Nodes*              nodes; //one set of nodes
-		Vertices*           vertices; //one set of vertices
-		Constraints*        constraints; //one set of constraints. each constraint knows which analysis_type it handles
-		Loads*              loads;  //one set of constraints. each constraint knows which analysis_type it handles
-		Materials*          materials;  //one set of materials, for each element
-		Parameters*         parameters; //one set of parameters, independent of the analysis_type
-		Results*            results; //results that cannot be fit into the elements (such as one time constants, arrays, strings, etc ...)
+		int          nummodels;
+		int          solution_type;
+		int         *analysis_type_list;   //list of analyses this femmodel is going to carry out
+		int          analysis_counter;     //counter into analysis_type_list
+
+		Profiler*    profiler;             //keep time, cpu and mem statistics while we are running.
+
+		Elements    *elements;             //elements (one set for all analyses)
+		Nodes       *nodes;                //one set of nodes
+		Vertices    *vertices;             //one set of vertices
+		Constraints *constraints;          //one set of constraints. each constraint knows which analysis_type it handles
+		Loads       *loads;                //one set of constraints. each constraint knows which analysis_type it handles
+		Materials   *materials;            //one set of materials, for each element
+		Parameters  *parameters;           //one set of parameters, independent of the analysis_type
+		Results     *results;              //results that cannot be fit into the elements 
+		COMM        comm;                  //communicator for this particular model
 
 		/*constructors, destructors: */
-		FemModel(char* rootpath, char* inputfilename, char* outputfilename, const int solution_type,const int* analyses,const int nummodels);
+		FemModel(int argc,char** argv,COMM comm_init);
+		FemModel(char* rootpath, char* inputfilename, char* outputfilename, char* petscfilename, char* lockfilename, const int solution_type,const int* analyses,const int nummodels);
 		~FemModel();
 
-		/*Methods: */
+		/*Methods:*/
+		void AllocateSystemMatrices(Matrix<IssmDouble>** pKff,Matrix<IssmDouble>** pKfs,Vector<IssmDouble>** pdf,Vector<IssmDouble>** ppf);
+		void CreateJacobianMatrixx(Matrix<IssmDouble>** pJff,IssmDouble kmax);
 		void Echo();
+		void InitFromFiles(char* rootpath, char* inputfilename, char* outputfilename, char* petscfilename, char* lockfilename, const int solution_type,const int* analyses,const int nummodels);
+		void MatrixNonzeros(int** pd_nnz,int** po_nnz,int set1enum,int set2enum);
+		void Solve(void);
+		void OutputResults(void);
+		void SetStaticComm();
+		void SetCurrentConfiguration(int configuration_type);
+		void SetCurrentConfiguration(int configuration_type,int analysis_type);
 
-		/*Fem: */
-		void  SetCurrentConfiguration(int configuration_type);
-		void  SetCurrentConfiguration(int configuration_type,int analysis_type);
-
+		/*Modules*/ 
+		#ifdef _HAVE_RESPONSES_
+		void MassFluxx(IssmDouble* presponse,bool process_units);
+		void MaxAbsVxx(IssmDouble* presponse,bool process_units);
+		void MaxAbsVyx(IssmDouble* presponse,bool process_units);
+		void MaxAbsVzx(IssmDouble* presponse,bool process_units);
+		void MaxVelx(IssmDouble* presponse,bool process_units);
+		void MaxVxx(IssmDouble* presponse,bool process_units);
+		void MaxVyx(IssmDouble* presponse,bool process_units);
+		void MaxVzx(IssmDouble* presponse,bool process_units);
+		void MinVelx(IssmDouble* presponse,bool process_units);
+		void MinVxx(IssmDouble* presponse,bool process_units);
+		void MinVyx(IssmDouble* presponse,bool process_units);
+		void MinVzx(IssmDouble* presponse,bool process_units);
+		void TotalSmbx(IssmDouble* pSmb,bool process_units);
+		void IceVolumex(IssmDouble* pV,bool process_units);
+		void ElementResponsex(IssmDouble* presponse,int response_enum,bool process_units);
+		#endif
+		#ifdef  _HAVE_DAKOTA_
+		void DakotaResponsesx(double* d_responses,char** responses_descriptors,int numresponsedescriptors,int d_numresponses);
+		#endif
+		void RequestedOutputsx(int* requested_outputs, int numoutputs);
+		void RequestedDependentsx(void);
+		void Responsex(IssmDouble* presponse,int response_descriptor_enum,bool process_units,int weight_index);
+		void Responsex(IssmDouble* presponse,const char* response_descriptor,bool process_units,int weight_index);
+		#ifdef _HAVE_CONTROL_
+		void CostFunctionx( IssmDouble* pJ);
+		void ThicknessAbsGradientx( IssmDouble* pJ, bool process_units,int weight_index);
+		#endif
+		void SystemMatricesx(Matrix<IssmDouble>** pKff, Matrix<IssmDouble>** pKfs, Vector<IssmDouble>** ppf, Vector<IssmDouble>** pdf, IssmDouble* pkmax);
+		void TimeAdaptx(IssmDouble* pdt);
+		void UpdateConstraintsx(void);
+		int  UpdateVertexPositionsx(void);
 };
 
Index: issm/trunk/src/c/classes/Hook.cpp
===================================================================
--- issm/trunk/src/c/classes/Hook.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/Hook.cpp	(revision 13975)
@@ -2,5 +2,4 @@
  * \brief: implementation of the Hook object: see Hook.h for more explanations.
  */
-
 
 #ifdef HAVE_CONFIG_H
@@ -18,20 +17,15 @@
 #include "../include/include.h"
 
-
 /*Constructor/Destructors*/
 /*FUNCTION Hook::Hook(){{{*/
 Hook::Hook(){
-	this->num=0;
-	this->objects=NULL;
-	this->ids=NULL;
-	this->offsets=NULL;
-	return;
+	this->num     = 0;
+	this->objects = NULL;
+	this->ids     = NULL;
+	this->offsets = NULL;
 }
 /*}}}*/
 /*FUNCTION Hook::Hook(int* ids, int num){{{*/
 Hook::Hook(int* in_ids, int in_num){
-
-	/*Intermediaries*/
-	int i;
 
 	/*Get number of objects to hook*/
@@ -41,7 +35,7 @@
 	if (num==0){
 		/*Empty hook*/
-		this->ids=NULL;
-		this->objects=NULL;
-		this->offsets=NULL;
+		this->ids     = NULL;
+		this->objects = NULL;
+		this->offsets = NULL;
 	}
 	else{
@@ -52,8 +46,8 @@
 
 		/*Copy ids: */
-		for (i=0;i<this->num;i++){
-			this->ids[i]=in_ids[i];
-			this->objects[i]=NULL;
-			this->offsets[i]=0;
+		for(int i=0;i<this->num;i++){
+			this->ids[i]     = in_ids[i];
+			this->objects[i] = NULL;
+			this->offsets[i] = 0;
 		}
 	}
@@ -62,9 +56,7 @@
 /*FUNCTION Hook::~Hook(){{{*/
 Hook::~Hook(){
-	/*deallocate: */
 	xDelete<Object*>(this->objects);
 	xDelete<int>(this->ids);
 	xDelete<int>(this->offsets);
-	return;
 }
 /*}}}*/
@@ -121,6 +113,4 @@
 Object* Hook::copy(void){
 
-	int i;
-
 	/*output: */
 	Hook* output=NULL;
@@ -132,13 +122,13 @@
 	output->num=this->num;
 	if(output->num){
-		output->objects=xNew<Object*>(output->num);
-		output->ids=xNew<int>(output->num);
-		output->offsets=xNew<int>(output->num);
-	}
-	
-	for(i=0;i<output->num;i++){
-		output->objects[i]=this->objects[i];
-		output->offsets[i]=this->offsets[i];
-		output->ids[i]=this->ids[i];
+		output->objects = xNew<Object*>(output->num);
+		output->ids     = xNew<int>(output->num);
+		output->offsets = xNew<int>(output->num);
+	}
+
+	for(int i=0;i<output->num;i++){
+		output->objects[i] = this->objects[i];
+		output->offsets[i] = this->offsets[i];
+		output->ids[i]     = this->ids[i];
 	}
 
@@ -183,5 +173,5 @@
 		/*Now, for this->objects that did not get resolved, and for which we have no offset, chase them in the dataset, by id: */
 		if(this->objects[i]==NULL){
-			this->objects[i]=(Object*)dataset->GetObjectById(this->offsets+i,this->ids[i]); //remember the offset for later on.
+			this->objects[i]=dynamic_cast<Object*>(dataset->GetObjectById(this->offsets+i,this->ids[i])); //remember the offset for later on.
 			/*check the id is correct!: */
 			if (this->objects[i]->Id()!=this->ids[i]) _error_("wrong id: " << this->objects[i]->Id() << " vs " << this->ids[i] << "  in resolved pointer!");
@@ -192,5 +182,5 @@
 /*FUNCTION Hook::delivers{{{*/
 Object* Hook::delivers(void){
-	
+
 	/*first, check that we only have one T object in our object list: */
 	if (this->num!=1) _error_("trying to delivery a single hook object when hook holds " << this->num << " objects" << "\n");
@@ -230,6 +220,4 @@
 /*FUNCTION Hook::Spawn{{{*/
 Hook* Hook::Spawn(int* indices, int numindices){
-
-	int i;
 
 	/*output: */
@@ -246,5 +234,5 @@
 
 	/*Else, check that we are requesting a half of num*/
-	if (numindices>this->num) _error_("Cannot spawn hook with " << numindices << " objects from a Hook of " << this->num << " objects");
+	if(numindices>this->num) _error_("Cannot spawn hook with " << numindices << " objects from a Hook of " << this->num << " objects");
 
 	/*go pickup the correct objects, ids and offsets :*/
@@ -252,12 +240,12 @@
 	if(output->num<1) _error_("Trying to spawn an empty ElementProperties!");
 
-	output->objects=xNew<Object*>(output->num);
-	output->ids=xNew<int>(output->num);
-	output->offsets=xNew<int>(output->num);
-
-	for(i=0;i<output->num;i++){
-		output->objects[i]=this->objects[indices[i]];
-		output->ids[i]=this->ids[indices[i]];
-		output->offsets[i]=this->offsets[indices[i]];
+	output->objects = xNew<Object*>(output->num);
+	output->ids     = xNew<int>(output->num);
+	output->offsets = xNew<int>(output->num);
+
+	for(int i=0;i<output->num;i++){
+		output->objects[i] = this->objects[indices[i]];
+		output->ids[i]     = this->ids[indices[i]];
+		output->offsets[i] = this->offsets[indices[i]];
 	}
 
Index: issm/trunk/src/c/classes/Hook.h
===================================================================
--- issm/trunk/src/c/classes/Hook.h	(revision 13405)
+++ issm/trunk/src/c/classes/Hook.h	(revision 13975)
@@ -19,8 +19,8 @@
 	private: 
 
-		int	   num; //number of objects being hooked onto
-		Object**	   objects; //list of object pointers. we do not allocate objects, just a list a pointers, that will get to point to the real objects from a dataset.
-		int*   ids;     //list of object ids, to go look for them in datasets.
-		int*   offsets;  //list of object offsets into datasets, to speed up lookup.
+		int      num;       //number of objects being hooked onto
+		Object **objects;   //list of object pointers
+		int     *ids;       //list of object ids, to go look for them in datasets.
+		int     *offsets;   //list of object offsets into datasets, to speed up lookup.
 
 	public:
